/***************************************************************************
                          guibalances.h  -  description
                             -------------------
    begin                : Do Nov 4 2004
    copyright            : (C) 2004 by Marcel Mulch
    email                : marcel@mulch-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GUIBALANCES_H
#define GUIBALANCES_H

#include <qwidget.h>
#include <qwidgetstack.h>
#include <qlistview.h>
#include "guibalancesbase.h"
#include "hobit.h"
#include <qlayout.h>
#include <guimain.h>

class GuiMain;

/**
* This is class for showing balances of all listed accounts
*/

class GuiBalances : public GuiBalancesBase  {
   Q_OBJECT
public: 

/**
* This is constructor of class for showing balances of all listed accounts
* @param main
* @param parent the parent dialog of this widget
* @param name widgets title
* @param hobit
*/
	GuiBalances(GuiMain *main, QWidgetStack *parent=0, const char *name=0, HoBIT* hobit = 0);
	~GuiBalances();
	
	/** set hobit object*/
	  void setHoBIT(HoBIT* hobit){
   	 _hobit = hobit;
  	}

    bool updateList();
    void refresh();
   
private:
  Pointer<HoBIT> _hobit;
  GuiMain* _main;
  
  QGridLayout *layout;
  
  /**
   * set the widgets base layout. will be called 
   * from the constructor only
   */ 
   void doLayout();
  
public slots: // Public slots

/**
*retrieves the balances of all accounts, if chosen
*/
  void slotGetBalances();
};

#endif
