/***************************************************************************
                          guistartstandingorder.cpp  -  description
                             -------------------
    begin                : Sa Nov 13 2004
    copyright            : (C) 2004 by Marcel Mulch
    email                : marcel@mulch-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "guistartstandingorder.h"
#include <qcombobox.h>
#include <qdatetime.h>
#include <qlineedit.h>
#include <qstring.h>
#include <qmessagebox.h>
#include <qdatetimeedit.h>
#include <qspinbox.h>
#include <qlayout.h>
#include <qpushbutton.h>
#include <qframe.h>
#include <qlabel.h>
#include <qvalidator.h>


/**
*constructor of GuiStartStandingOrder
*
*@param main a pointer on moneypenny´s main class
*@param parent a pointer on the main widgets widget stack
*@param name widgets title
*@param hobit the hobit object, needed for hbci functions
*/
GuiStartStandingOrder::GuiStartStandingOrder(QWidget *parent, GuiMain *guimain,  const char *name, HoBIT* hobit )
:GuiTransferForm(parent, guimain, name, hobit) {
  refresh();
}


/**
*destructor of GuiStartStandingOrder
*/
GuiStartStandingOrder::~GuiStartStandingOrder(){
qDebug("Destructor GuiStartStandingOrder finished");
}




/** 
*called function after pressing button of formular,
*gets current inputs of formular for transferjob  
*/
void GuiStartStandingOrder::accept(){

// check if all necessary fields are not empty, otherwise errormessage
if(lineEditOtherName->text() == ' ' || lineEditOtherBankCode->text() == ' ' || lineEditOtherAccountId->text() == ' ' || lineEditValue->text() == ' ')QMessageBox::warning( this,
                                                    tr("Error"),
                                                      tr("Please fill out all fields. Purpose fields are not necessary."),
                                                     "&OK",
                                                      QString::null, 0, 1 ) ;
else{
QString ourAccount = _main->getCurrentAccount();
QString name = lineEditOtherName->text();
QString bankCode = lineEditOtherBankCode->text();
QString accountId = lineEditOtherAccountId->text();
QString purpose1 =  lineEditPurpose->text();
QString purpose2 =  lineEditPurpose2->text();
QString value = lineEditValue->text();
QDate d = dateEditFirst->date();

int day = spinBoxDay->value();

bool weekly = true;
int turnus = 0;

switch(comboBoxTurnus->currentItem()){

  case 0:           weekly = false;
                        turnus = 1;
                        break;
  case 1:           weekly = false;
                        turnus = 3;
                        break;
  case 2:           weekly = false;
                        turnus = 6;
                        break;
  case 3:           weekly = false;
                        turnus = 12;
                        break;
  case 4:           weekly = true;
                        turnus = 1;
                        break;  
}

Date firstdate(d.day(), d.month(), d.year());
d = dateEditLast->date();
Date lastdate(d.day(), d.month(), d.year());

Value val(value.ascii(), "EUR");

list<string> oname;
oname.push_back(name.ascii());

list<string> purpose;
purpose.push_back(purpose1.ascii());
purpose.push_back(purpose2.ascii());

QString text =    "Sie sind dabei folgende �erweisung zu t�igen \n";
text += "\nAusgangskonto:      ";
text +=  ourAccount;
text +=  "\nEmpf�gerkonto:   ";
text += accountId;
text += "\nbei Bank:              ";
text += bankCode;
text += "\nBetrag                  ";
text += value;
text += " EUR";
text += "\n\nVerwendungszweck:\n";
text += purpose1;
text += "\n";
text += purpose2;


bool no = QMessageBox::question( this,
                                                    "Auftrag bet�igen",
                                                      text,
                                                     "&Ja", "&Nein",
                                                      QString::null, 0, 1 ) ;

      if (!no) {
       int err = _hobit->createJobStartStandingOrder(  SKIP_FALSE_TRANSACTIONS,  // skipbad
                                                       MONEYPENNY_DEFAULT_COUNTRY,                 // country
                                                       "*",                 // bankcode
                                                       ourAccount.ascii(),  // accountid
                                                       "", 		   // accountSubId
                                                       MONEYPENNY_DEFAULT_COUNTRY,                 // other country
                                                       bankCode.ascii(),    // other bankcode
                                                       accountId.ascii(),   // other account
                                                       oname,               // other name
                                                       purpose,             // purpose
                                                       val,                 // value
                                                       53, 	           // textkey
                                                       firstdate,           // normal date
                                                       firstdate,           // first date
                                                       lastdate,            // last date
                                                       turnus,              // turnus
                                                       weekly,              // weekly
                                                       day);                // day
			
        if(err != HobitErrorSuccess)
          qDebug("GuiStartStandingOrder::accept: Error creating JobStartStandingOrder. Error Code: %i", err);
      _hobit->createJobGetStandingOrders();					     
      if(_main->askForSend())
       _main->slotSendNow();
      _main->widgetStack->raiseWidget(STANDING_ORDERS_WIDGET);
      }

}}

