/***************************************************************************
 *   Copyright (C) 2004 by Walter Roth                                     *
 *   walter@amd2600-roth                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "hobit_bank.h"

#include <qstringlist.h>


HoBIT_Bank::HoBIT_Bank()
{
}


HoBIT_Bank::~HoBIT_Bank()
{
}


/** Sets the memberfields from a single line of the .csv file.
*/
bool HoBIT_Bank::setFromCsvLine(const QString  & csvLine){
   QStringList row = QStringList::split( ";", csvLine );
   if(row[1].length() == 8){  //BankId (BLZ) must have exactly 8 digits
     _BankId = row[1];
     _BankName = row[2];
     _Location = row[3]; 
     if(row[6].length() !=0)
       _Server = row[6];  //Url
     else _Server = row[7];  //IP address
     return true;
   }
   else return false;
}

/** Read property of QString _BankName. 
*/
const QString& HoBIT_Bank::getBankName()const{
	return _BankName;
}

/** Write property of QString _BankName. 
*/
void HoBIT_Bank::setBankName( const QString& _newVal){
	_BankName = _newVal;
}

/** Read property of QString _BankId. 
*/
const QString& HoBIT_Bank::getBankId()const{
	return _BankId;
}

/** Write property of QString _BankId. 
*/
void HoBIT_Bank::setBankId( const QString& _newVal){
	_BankId = _newVal;
}


/** Read property of QString _Location. 
*/
const QString& HoBIT_Bank::getLocation()const{
	return _Location;
}

/** Write property of QString _Location. 
*/
void HoBIT_Bank::setLocation( const QString& _newVal){
	_Location = _newVal;
}


/** Read property of QString _Server. 
*/
const QString& HoBIT_Bank::getServer()const{
	return _Server;
}

/** Write property of QString _Server. 
*/
void HoBIT_Bank::setServer( const QString& _newVal){
	_Server = _newVal;
}

/** Reads a line from bankdata.txt
*/
bool HoBIT_Bank::setFromTxtLine(const QString & txtLine){
   QStringList row = QStringList::split( "\t", txtLine );
   if(row[0].length() == 8){  //BankId (BLZ) must have exactly 8 digits
     _BankId = row[0];
     _BankName = row[2];
     _Location = row[3];    
     _Server = "unknown";  //Url is not in list
     return true;
   }
   else return false;
}
