/***************************************************************************
                          hobit_string.cpp  -  description
                             -------------------
    begin                : Mi Okt 20 2004
    copyright            : (C) 2004 by Marcel Mulch
    email                : marcel@mulch-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "hobit_string.h"
#include <string>
#include <stdio.h>
#include <stdarg.h>
#include "qobject.h"
using namespace std;

const string HoBIT_String::format(const char *fmt, ...) {
  va_list ap;
  char *buf = 0;
  size_t size;
  string str="";

  va_start(ap,fmt);
  size = vsnprintf(buf,0,fmt,ap);
  va_end(ap);
  if (size > 0) {
    size++;
    buf=new char[size];
    va_start(ap,fmt);
    vsnprintf(buf,size,fmt,ap);
    va_end(ap);
    str=buf;
    delete[] buf;
  }
  return str;
}



/** dumps a hex string, so it can be
  * printed to the ini letter
  */
const string HoBIT_String::dumpHexString(string s) {
    string result;
    unsigned int pos;

    result+="   ";
    for (pos=0; pos < s.length(); pos++) {
        if ((pos % 40)==0)
            result+="\n   ";
        else if ((pos & 1)==0)
            result+=" ";
        result+=s.at(pos);
    } // for
    result+="\n";
    return result;
}

/** dumps a char array, so it can be
  * printed to the ini letter
  */
const string HoBIT_String::dumpHexString(char * data, int length) {
 string temp(data, length);
 return dumpHexString(temp); 
}

/**removes German Umlaute or other special chars illegal for HBCI
*/
const QString  HoBIT_String::replaceSpecialChars(const QString & text){
   QString buffer;
   for(uint pos = 0; pos < text.length(); pos ++){
    if((text[pos])== QString::fromUtf8("ä")) 
           buffer += "ae"; 
    else if((text[pos])== QString::fromUtf8("Ä")) 
           buffer += "Ae"; 
    else if((text[pos])== QString::fromUtf8("ö")) 
           buffer += "oe"; 
    else if((text[pos])== QString::fromUtf8("Ö")) 
           buffer += "Oe"; 
    else if((text[pos])== QString::fromUtf8("ü")) 
           buffer += "ue"; 
    else if((text[pos])== QString::fromUtf8("Ü")) 
           buffer += "Ue"; 
    else if((text[pos])== QString::fromUtf8("ß")) 
           buffer += "ss"; 
         else buffer+= text[pos]; 
   }//end for
   return buffer;  
}

