/***************************************************************************
                          hobit_string.h  -  description
                             -------------------
    begin                : Mi Okt 20 2004
    copyright            : (C) 2004 by Marcel Mulch
    email                : marcel@mulch-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef HOBIT_STRING_H
#define HOBIT_STRING_H

#include <string>
#include "qstring.h"
using namespace std;


/**This class is a helper class for string handling inspired by AqMoney
  *@author Marcel Mulch
  */

class HoBIT_String {
public:
  /**
   * sprintf like function returning string
   */
  static const string format(const char *fmt, ...);

   /** dumps a hex string, so it can be
   * printed to the ini letter
   */
  static const string dumpHexString(string s);
   /** dumps a char array, so it can be
   * printed to the ini letter
   */
  static const string dumpHexString(char * data, int length);
  
  /**removes German Umlaute or other special chars illegal for HBCI
  */
  static const QString replaceSpecialChars(const QString & text);
};

#endif
