/***************************************************************************
 *   Copyright (C) 2004 by Marcel Mulch                                    *
 *   marcel@mulch-online.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "hobit_transfertemplate.h"

HoBIT_TransferTemplate::HoBIT_TransferTemplate(	const string& ownAccountId,
						const string& otherName, 
			   			const string& otherAccountId,
			   			const string& otherBank,
			   			const Value& value,
			   			const string purpose1,
						const string purpose2)
{
	_ownAccountId = ownAccountId;
	_otherName = otherName;
	_otherAccountId = otherAccountId;
	_otherBank = otherBank;
	_value = value;
	_purpose1 = purpose1;
	_purpose2 = purpose2;
	
}


HoBIT_TransferTemplate::HoBIT_TransferTemplate(GWEN_DB_NODE *db) {
	fromConfig(db);
}



HoBIT_TransferTemplate::~HoBIT_TransferTemplate()
{
}


void HoBIT_TransferTemplate::fromConfig(GWEN_DB_NODE *db){
  _ownAccountId=GWEN_DB_GetCharValue(db, "ownAccountId", 0, "");
  _otherName=GWEN_DB_GetCharValue(db, "otherName", 0, "");
  _otherAccountId=GWEN_DB_GetCharValue(db, "otherAccountId", 0, "");
  _otherBank=GWEN_DB_GetCharValue(db, "otherBankId", 0, "");
  _value=Value(GWEN_DB_GetCharValue(db, "value/value", 0, "0,0"),
               GWEN_DB_GetCharValue(db, "value/currency", 0, "EUR"));
	       
  _purpose1=GWEN_DB_GetCharValue(db, "purpose/line1", 0, "");
  _purpose2=GWEN_DB_GetCharValue(db, "purpose/line2", 0, "");

}



void HoBIT_TransferTemplate::toConfig(GWEN_DB_NODE *db){
   GWEN_DB_SetCharValue(db, GWEN_DB_FLAGS_DEFAULT,
                       "ownAccountId",
                       _ownAccountId.c_str());
   GWEN_DB_SetCharValue(db, GWEN_DB_FLAGS_DEFAULT,
                        "otherName",
                        _otherName.c_str());
   GWEN_DB_SetCharValue(db, GWEN_DB_FLAGS_DEFAULT,
                       "otherAccountId",
                       _otherAccountId.c_str());
   GWEN_DB_SetCharValue(db, GWEN_DB_FLAGS_DEFAULT,
                        "otherBankId",
                        _otherBank.c_str());
   GWEN_DB_SetCharValue(db, GWEN_DB_FLAGS_DEFAULT,
                        "value/value",
                        _value.toString(true).c_str());
   GWEN_DB_SetCharValue(db, GWEN_DB_FLAGS_DEFAULT,
                        "value/currency",
                        _value.getCurrency().c_str());
   GWEN_DB_SetCharValue(db, GWEN_DB_FLAGS_DEFAULT,
                        "purpose/line1",
                        _purpose1.c_str());
   GWEN_DB_SetCharValue(db, GWEN_DB_FLAGS_DEFAULT,
                        "purpose/line2",
                        _purpose2.c_str());
}

